;QWave
;Version 1.9
;14/12/2022
;
;(c) Copyright 2022 Andrew J Glina
;
;Plays Audio files
;
;
; Assembles with MASM32
;
; This program is not free, nor is it "Open Source". This source is provided for education and reference purposes only. You 
; are not permitted, for example, to assemble this program and produce a program (or module of a program) of similar or same 
; function. However, if the program is substantially more featured, you are permitted to use any or all of this code within 
; that program, even if you wish to sell that program, providing it is an integral part of the program and not just an 
; external module or library. There is no requirement to credit me at all, but I would appreciate being notified. You are 
; also free to distribute this file as long as no part of it is changed. Please contact me for further details.
;
; I hope this file is of assistance to anyone starting MASM32.
;
;Andrew J Glina 
;Sinner Computing
;Support@SinnerComputing.com
;https://SinnerComputing.com


; __UNICODE__ equ 1
.686p
.mmx
.xmm
.model flat,stdcall
option casemap:none



;MASM32 Libs
include ..\..\..\include\windows.inc
include ..\..\..\include\masm32.inc
includelib ..\..\..\lib\masm32.lib

;Needed for Registry Commands
include ..\..\..\include\advapi32.inc
includelib ..\..\..\lib\advapi32.lib

;Needed for Window Handling
include ..\..\..\include\user32.inc
includelib ..\..\..\lib\user32.lib

;Needed for System
include ..\..\..\include\kernel32.inc
includelib ..\..\..\lib\kernel32.lib

;Needed for AboutBox and TrayIcon
include ..\..\..\include\shell32.inc
includelib ..\..\..\lib\shell32.lib

;Needed For Sound
include ..\..\..\include\winmm.inc
includelib ..\..\..\lib\winmm.lib



RegIt proto :DWORD, :DWORD, :DWORD, :DWORD, :BOOL
SetReg proto

.data?
hInst HINSTANCE ?
dHandle DWORD ?
dNote NOTIFYICONDATAAX <>
dWndCls WNDCLASSEX <>
dMSG MSG <>
sFileName BYTE 1200 dup(?)
hMCI HANDLE ?
hLib HANDLE ?
pCreate DWORD ?
dEnd DWORD ?
sBuffA BYTE 1200 dup(?)
sBuffB BYTE 1200 dup(?)
sBuffC BYTE 1200 dup(?)

.const
sMCIWndCreate db "MCIWndCreate",0
sClassName db "QWave",0
sAdd db "Add QPlay to menu?",0
sRem db "Remove QPlay from menu?",0
sRegAll db "*\shell\QPlay",0
sRegCmd db "\Command",0
sExeName db "QWave.exe",0
sSuf db " ",34,"%1",34,0
mStop equ WM_USER+5h
sMMLib db "msvfw32.dll",0
MCIWNDF_NOOPEN equ 8000h
MCIWNDOPENF_NEW equ 1h
MCIWNDM_GETPOSITIONA equ 466h
MCIWNDM_GETEND equ 469h
MCIWNDF_NOERRORDLG equ 4000h

.code

main:

  invoke GetModuleHandle, NULL
  mov hInst, eax

  invoke getcl_ex, 1, addr sFileName
  .if eax==1
    invoke LoadLibrary, addr sMMLib 
    mov hLib, eax
    invoke GetProcAddress, eax, addr sMCIWndCreate
    mov pCreate, eax
    mov dWndCls.cbSize, SIZEOF WNDCLASSEX
    mov dWndCls.lpfnWndProc, offset MainWnd
    push hInst
    pop dWndCls.hInstance
    mov dWndCls.lpszClassName, offset sClassName
    invoke RegisterClassEx, addr dWndCls
    invoke CreateWindowEx, WS_EX_CLIENTEDGE, addr sClassName, addr sExeName, WS_OVERLAPPED, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, NULL, NULL, hInst, NULL
    mov dHandle, eax
    push offset sFileName
    push MCIWNDF_NOOPEN or MCIWNDF_NOERRORDLG or MCIWNDF_NOPLAYBAR or MCIWNDF_NOMENU or WS_POPUP
    push hInst
    push dHandle
    call pCreate
    mov hMCI, eax
    pop eax
    pop eax
    pop eax
    pop eax
    invoke SendMessage, hMCI, MCIWNDM_GETEND, 0, 0
    mov dEnd, eax
    invoke SendMessage, hMCI, MCI_PLAY, 0, 0

    .while TRUE
      invoke GetMessage, addr dMSG, NULL, 0, 0
      .break .if (!eax)
      invoke DispatchMessage, addr dMSG 
    .endw
    invoke Shell_NotifyIcon, NIM_DELETE, addr dNote
   .else
    invoke SetReg
  .endif
  invoke ExitProcess, hInst


MainWnd proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

  .if uMsg==WM_DESTROY
    invoke PostQuitMessage, NULL

   .elseif uMsg==WM_CREATE
    mov dNote.cbSize, sizeof NOTIFYICONDATAAX
    push hWnd
    pop dNote.hwnd
    xor eax, eax
    mov dNote.uID, eax
    invoke szCopy, addr sClassName, addr dNote.szTip
    mov dNote.uFlags, NIF_ICON or NIF_MESSAGE or NIF_TIP
    mov dNote.uCallbackMessage, mStop
    invoke LoadIcon, hInst, 500
    mov dNote.hIcon, eax
    mov dNote.uVersion, NOTIFYICON_VERSION

    invoke Shell_NotifyIcon, NIM_ADD, addr dNote
    invoke SetTimer, hWnd, 1, 1000, NULL
 
   .elseif uMsg==WM_TIMER
    invoke SendMessage, hMCI, MCIWNDM_GETPOSITIONA, 0, 0
    .if eax==dEnd
      invoke DestroyWindow, hWnd
    .endif

   .elseif uMsg==mStop
    invoke DestroyWindow, hWnd

   .else
    invoke DefWindowProc, hWnd, uMsg, wParam, lParam
  .endif
  ret

MainWnd endp


SetReg proc

  invoke SearchPath, NULL, addr sExeName, NULL, 600, addr sBuffA, NULL
  invoke szCatStr, addr sBuffA, addr sSuf
  invoke szCopy, addr sRegAll, addr sBuffC
  invoke szCatStr, addr sBuffC, addr sRegCmd
  invoke RegIt, HKEY_CLASSES_ROOT, offset sBuffC, NULL, offset sBuffB, FALSE
  invoke lstrcmp, addr sBuffB, addr sBuffA
  .if eax==0
    invoke MessageBox, NULL, addr sRem, addr sClassName, MB_OKCANCEL or MB_ICONQUESTION
    .if eax==IDOK
      invoke RegDeleteKey, HKEY_CLASSES_ROOT, addr sBuffC
      invoke RegDeleteKey, HKEY_CLASSES_ROOT, addr sRegAll
    .endif
   .else
    invoke MessageBox, NULL, addr sAdd, addr sClassName, MB_OKCANCEL or MB_ICONQUESTION
    .if eax==IDOK
      invoke RegIt, HKEY_CLASSES_ROOT, offset sBuffC, NULL, offset sBuffA, TRUE
    .endif
  .endif
  ret

SetReg endp


RegIt proc dHKey:DWORD, sKey:DWORD, sSubKey:DWORD, sValue:DWORD, fWrite:BOOL

LOCAL dTmpA:DWORD
LOCAL hReg:HANDLE

  invoke RegCreateKeyEx, dHKey, sKey, 0, NULL, 0, KEY_ALL_ACCESS, 0, addr hReg, NULL
  .if fWrite
    invoke lstrlen, sValue
    mov dTmpA, eax
    invoke RegSetValueEx, hReg, sSubKey, 0, REG_SZ, sValue, dTmpA
   .else
    mov eax, 600
    mov dTmpA, eax
    invoke RegQueryValueEx, hReg, sSubKey, NULL, NULL, sValue, addr dTmpA
  .endif
  invoke RegCloseKey, hReg
  ret

RegIt endp

end main

